
; BIOS fuer CPD3

		TITLE	CPD3BIOS

		.Z80




; **********************************************************
;                   BIOS Sprungvektoren
; **********************************************************




             ; IM FOLGENDEN STEHEN DIE 17 VON CPM DEFINIERTEN
             ; SPRUNGVEKTOREN ZU DEN EINZELNEN EIN-/AUSGABE-
             ; FUNKTIONEN UND DISKETTEN-ROUTINEN

		JP	CBOOT		; (00) Kaltstartroutine
WBOOTE:		JP	WBOOT		; (01) Warmstartroutine
		JP	CONST		; (02) CONSOLE-Status abfragen
		JP	CONIN		; (03) CONSOLE-Eingabe
		JP	CONOUT		; (04) CONSOLE-Ausgabe
		JP	LIST		; (05) LIST-Ausgabe
		JP	PUNCH		; (06) PUNCH-Ausgabe
		JP	READER		; (07) READER-Eingabe
		JP	HOME		; (08) Spur Null einstellen
		JP	SELDSK		; (09) Laufwerk auswhlen
		JP	SETTRK		; (10) Spur auswhlen
		JP	SETSEC		; (11) Sektor auswhlen
		JP	SETDMA		; (12) Datenpufferadresse setzen
		JP	READ		; (13) Selektierten Sektor lesen
		JP	WRITE		; (14) Selektierten Sektor schreiben
		JP	LISTST		; (15) LIST-Status abfragen
		JP	SECTRAN		; (16) Umrechnen Sektornumme

		JP	Monitor		; Monitor



; **********************************************************
;                  Hardware Speicherzellen
; **********************************************************


MonFkt_B:	DB	0
Conn_B:		DB	0
Ergebnis_B:	DB	0
ErgPar1_B:	DB	0


DMA_ARRAY:
		DS	128,0



D_ITP2_TAB:
		DB	D_ITP2_CON1
		DB	D_ITP2_CON2
		DB	D_ITP2_CON3
		DB	D_ITP2_CON4
		DB	D_ITP2_CON5

C_ITP2_TAB:
		DB	C_ITP2_CON1
		DB	C_ITP2_CON2
		DB	C_ITP2_CON3
		DB	C_ITP2_CON4
		DB	C_ITP2_CON5



; **********************************************************
;                   MONITOR Speicherzellen
; **********************************************************



VAR_SECNT:	DB	0		; Anzahl der Sektoren fuer das BOOT-File
ROMBANK:	DB	00H		; Speicherstelle fuer die ROM-BANK 



ZK_START:
		DB	0CH		; Clear Screen
		DB	'CP/M 2.2 Copyright 1979 (c) by Digital Research',0DH,0AH
		DB	'BIOS-Monitor 2012 written by Ronald Daleske',0DH,0AH,0DH,0AH,0

ZK_EINGABE:
		DB	"Zeichen=",0

ZK_CRLF:	
		DB	0DH,0AH,0

ZK_ANZ_SE:
		DB	0DH,0AH,"Anzahl der Sektoren der BOOT-Datei=",0


ZK_Sektor:
		DB	"Sektor=",0

ZK_Spur:
		DB	0DH,0AH,"Spur=",0

ZK_LW:
		DB	0DH,0AH,"Laufwerk=",0


ZK_S:
		DB	"S=",0

ZK_T:
		DB	" T=",0

ZK_D:
		DB	" D=",0

ZK_B:
		DB	" B=",0

ZK_A:
		DB	" A=",0


ZK_CONN:
		DB	"Connector("
CONN_NR:
		DB	"1) -> ",0
ZK_DEV_2:
		DB	"PC-CP/M-Emulator",0DH,0AH,0
ZK_DEV_3:
		DB	"Tastatur",0DH,0AH,0
ZK_DEV_4:
		DB	"LC-Display",0DH,0AH,0
ZK_DEV_5:
		DB	"RAM-Floppy",0DH,0AH,0
ZK_DEV_6:
		DB	"Tastatur und VGA",0DH,0AH,0
ZK_CONN_END:
		DB	0DH,0AH,0




; **********************************************************
;                   BIOS Speicherzellen und Texte
; **********************************************************

SECTOR:		DB	00H		; Sektor
TRACK:		DW	0002H		; Spur
DISKNO:		DB	00H		; Laufwerksnummer
DMAAD:		DW	80H		; DMA-Adresse


ANZ_LW		EQU	3		; Anzahl der Laufwerke (von 1 beginnend)


temp:		DB	00H


DPH:

;Diskettenparameterkopf (DPH0)
; fuer die serielle Festplatte (ueber RS232)
;
DPH0:		DW	0		;Adresse der Konvertierungs-
					;tabelle (hier 0000H)
		DW	4		;Notizspeicher fuer das BDOS
					; (gesammt = 6 Byte)
		DW	4
		
		DW	80H
		
		;
		DW	DIRBUFF		;Adresse eines 128 Byte grossen
					;Puffers fuer die Arbeit mit 
					;dem Inhaltsverzeichnis
		DW	DPB0		;Adresse des Diskettenpara-
					;meterblockes
		DW	CSV0		;Adresse eines Notizspeichers
					;fuer die softwaremaessige 
					;Erkennung des Diskettenwechsels
		DW	ALV0		;Adresse eines Notizspeichers
					;fuer die Belegungsinformation



;Diskettenparameterkopf (DPH1)
; fuer die ROM-FLOPPY (FLASH)
;
DPH1:		DW	0		;Adresse der Konvertierungs-
					;tabelle (hier 0000H)
		DW	4		;Notizspeicher fuer das BDOS
					; (gesammt = 6 Byte)
		DW	4
		
		DW	80H
		
		;
		DW	DIRBUFF		;Adresse eines 128 Byte grossen
					;Puffers fuer die Arbeit mit 
					;dem Inhaltsverzeichnis
		DW	DPB1		;Adresse des Diskettenpara-
					;meterblockes
		DW	CSV1		;Adresse eines Notizspeichers
					;fuer die softwaremaessige 
					;Erkennung des Diskettenwechsels
		DW	ALV1		;Adresse eines Notizspeichers
					;fuer die Belegungsinformation


;Diskettenparameterkopf (DPH2)
; fuer die RAM-FLOPPY (FLASH)
;
DPH2:		DW	0		;Adresse der Konvertierungs-
					;tabelle (hier 0000H)
		DW	4		;Notizspeicher fuer das BDOS
					; (gesammt = 6 Byte)
		DW	4
		
		DW	80H
		
		;
		DW	DIRBUFF		;Adresse eines 128 Byte grossen
					;Puffers fuer die Arbeit mit 
					;dem Inhaltsverzeichnis
		DW	DPB2		;Adresse des Diskettenpara-
					;meterblockes
		DW	CSV2		;Adresse eines Notizspeichers
					;fuer die softwaremaessige 
					;Erkennung des Diskettenwechsels
		DW	ALV2		;Adresse eines Notizspeichers
					;fuer die Belegungsinformation


; Disketten Parameter Block (DPB0)
; ===============================
; fuer die serielle Festplatte (ueber RS232)
;
; spt=72,bsh=4,blm=15,exm=0,dsm=710,drm=255,al0=0f0h,al1=0,cks=64,off=2
;
DPB0:
; Number of 128-byte records per track
spt0:		DW	72		;Anzahl der Sektoren auf einer Spur 

; Block shift. 3 => 1k, 4 => 2k, 5 => 4k....
bsh0:		DB	4		;Blockverschiebungsfaktor
					;= LOG2(Blockgroesse/128)
					; LOG2 = Logarithmus zur Basis 2
					; LOG2(2048/128) = 4

; Block mask. 7 => 1k, 0Fh => 2k, 1Fh => 4k...
blm0:		DB	15		;Blockmaske = Anzahl der Sekto-
					;ren pro Block - 1
					;BLM = (2^BSH)-1
; Extent mask, see later
exm0:		DB	0		;Extentmaske

; (no. of blocks on the disc)-1
dsm0:		DW	710		;Anzahl der Bloecke pro Diskette minus 1
					;(einschliesslich des Verzeich-
	 				; nisses aber ohne Systemspuren)
; (no. of directory entries)-1
drm0:		DW	255		;max. Anzahl der Eintraege im 
					;Inhaltsverzeichnis - 1 = 256 - 1
; Directory allocation bitmap, first byte
al00:		DB	0f0h		;reservierten Eintraege fuer das
					;Inhaltsverzeichnis = 4 Blocke
; Directory allocation bitmap, first byte
AL10:		DB	00000000B	

; Checksum vector size, 0 or 8000h for a fixed disc.
;No. directory entries/4, rounded up.
cks0:		DW	64		;Laenge des Diskettenpuffervektors
					;tors = (DRM+1)/4 = (255+1)/4 = 64

; Offset, number of reserved tracks
off0:		DW	2		;Anzahl der reservierten Spuren
					;am Anfang der Diskette = 2

		DS	8



; Disketten Parameter Block (DPB1)
; ===============================
; fuer die ROM-FLOPPY (FLASH)
;
; spt=72,bsh=4,blm=15,exm=0,dsm=710,drm=255,al0=0f0h,al1=0,cks=64,off=2
;
DPB1:
; Number of 128-byte records per track
spt1:		DW	72		;Anzahl der Sektoren auf einer Spur 

; Block shift. 3 => 1k, 4 => 2k, 5 => 4k....
bsh1:		DB	4		;Blockverschiebungsfaktor
					;= LOG2(Blockgroesse/128)
					; LOG2 = Logarithmus zur Basis 2
					; LOG2(2048/128) = 4

; Block mask. 7 => 1k, 0Fh => 2k, 1Fh => 4k...
blm1:		DB	15		;Blockmaske = Anzahl der Sekto-
					;ren pro Block - 1
					;BLM = (2^BSH)-1
; Extent mask, see later
exm1:		DB	0		;Extentmaske

; (no. of blocks on the disc)-1
dsm1:		DW	710		;Anzahl der Bloecke pro Diskette minus 1
					;(einschliesslich des Verzeich-
	 				; nisses aber ohne Systemspuren)
; (no. of directory entries)-1
drm1:		DW	255		;max. Anzahl der Eintraege im 
					;Inhaltsverzeichnis - 1 = 256 - 1
; Directory allocation bitmap, first byte
al01:		DB	0f0h		;reservierten Eintraege fuer das
					;Inhaltsverzeichnis = 4 Blocke
; Directory allocation bitmap, first byte
AL11:		DB	00000000B	

; Checksum vector size, 0 or 8000h for a fixed disc.
;No. directory entries/4, rounded up.
cks1:		DW	64		;Laenge des Diskettenpuffervektors
					;tors = (DRM+1)/4 = (255+1)/4 = 64

; Offset, number of reserved tracks
off1:		DW	2		;Anzahl der reservierten Spuren
					;am Anfang der Diskette = 2

		DS	8






; Disketten Parameter Block (DPB1)
; ===============================
; fuer die RAM-FLOPPY (FLASH)
;
; spt=72,bsh=4,blm=15,exm=0,dsm=710,drm=255,al0=0f0h,al1=0,cks=64,off=2
;
DPB2:
; Number of 128-byte records per track
spt2:		DW	72		;Anzahl der Sektoren auf einer Spur 

; Block shift. 3 => 1k, 4 => 2k, 5 => 4k....
bsh2:		DB	4		;Blockverschiebungsfaktor
					;= LOG2(Blockgroesse/128)
					; LOG2 = Logarithmus zur Basis 2
					; LOG2(2048/128) = 4

; Block mask. 7 => 1k, 0Fh => 2k, 1Fh => 4k...
blm2:		DB	15		;Blockmaske = Anzahl der Sekto-
					;ren pro Block - 1
					;BLM = (2^BSH)-1
; Extent mask, see later
exm2:		DB	0		;Extentmaske

; (no. of blocks on the disc)-1
dsm2:		DW	710		;Anzahl der Bloecke pro Diskette minus 1
					;(einschliesslich des Verzeich-
	 				; nisses aber ohne Systemspuren)
; (no. of directory entries)-1
drm2:		DW	255		;max. Anzahl der Eintraege im 
					;Inhaltsverzeichnis - 1 = 256 - 1
; Directory allocation bitmap, first byte
al02:		DB	0f0h		;reservierten Eintraege fuer das
					;Inhaltsverzeichnis = 4 Blocke
; Directory allocation bitmap, first byte
AL12:		DB	00000000B	

; Checksum vector size, 0 or 8000h for a fixed disc.
;No. directory entries/4, rounded up.
cks2:		DW	64		;Laenge des Diskettenpuffervektors
					;tors = (DRM+1)/4 = (255+1)/4 = 64

; Offset, number of reserved tracks
off2:		DW	2		;Anzahl der reservierten Spuren
					;am Anfang der Diskette = 2

		DS	8







;BDOS - Notizspeicher
DIRBUFF:	DS	128,0		;IHV - Puffer
ALV0:		DS	128,0		;Belegungsvektor dsm/8
CSV0:		DS	64,0		;Pruefvektor 0
		;
ALV1:		DS	128,0		;Belegungsvektor dsm/8
CSV1:		DS	64,0		;Pruefvektor 0
		;
ALV2:		DS	128,0		;Belegungsvektor dsm/8
CSV2:		DS	64,0		;Pruefvektor 0


		DS	32,0		; Ersatz




; **********************************************************
;                   BIOS Routinen
; **********************************************************






; *** CBOOT ***
; BIOS-Funktion (00) : Kaltstartroutine
; CBOOT, Cold BOOT : Kaltstart ausfhren
;
; Der Kaltstart wird nur nach dem erstmaligen Laden des Betriebsystems
; bentigt.
; Der Aufruf an den Kaltstart erfolgt meist von einem speziellen
; Ladeprogramm, das nach dem Einschalten des Rechners, das
; BIOS von der Systemdiskette geladen hat.
; Aufgabe des Kaltstart ist es, die einzelnen Systemkomponenten
; zu initialisieren und eine Meldung ber den erfolgten Systemstart
; auf der Console auszugeben.
; Falls der CCP und das BDOS bereits im Speicher stehen, kann
; nach dem Kaltstart sofort der CCP aktiviert werden. In diesem
; Fall mssen aber die beiden Sprungbefehle an den Adressen
; BOOT (nach BIOS+0003h) und BOOT+0005h (nach FBASE+OOO6h)
; eingesetzt sein. Normalerweise wird nach einem Kaltstart ein
; Warmstart ausgefhrt, der den CCP und das BDOS von der Diskette
; ldt und die Sprungbefehle einsetzt. Dann braucht nur
; die zuerst anzuwhlende Disk- und Usernummer in die Speicheradresse
; BOOT+0004h eingetragen zu werden.
;
; Aufruf: CBOOT
;
; Uebergabeparameter: keine
; Rueckgabeparameter: Sprung zum CCP oder bergang in die Warmstart-Funktion
;

CBOOT:		

		;
		LD	SP,STACK	;STACKPOINTER SETZEN
		;
		LD	HL,ZK_START	; Anzeige des Kaltstarttextes
		CALL	AUS_ZK
		;

		; Anzeige der angeschlossenen Connectoren und der Geraete
		CALL	DISPLAY_CONN


		XOR	A         	;AKKU loeschen
		LD	(IOBYTE),A	;I/O-BYTE loeschen
		LD	(USERLW),A 	;LAUFWERK 0
		;
		LD	(RAM_SYSREG),A	; Grundeinstellung fuer PIO 2 Port A
		LD	(ROMBANK),A		; ROMBANK=0






; (01) Warmstartroutine
WBOOT:
		;
		LD	SP,STACK	;STACKPOINTER SETZEN
		;

		; *** ROM einschalten ***
		; Umschalten der Speicherbank von RAM -> ROM
		XOR	A
		LD	(ROMBANK),A		; ROMBANK=0
		CALL	ROMSEL
		;
		; CCP von EEPROM laden
		;
		LD	HL,EEROMCCP	; CCP vom EEROM copieren
		LD	DE,CCPBASE
		LD	BC,CCPLEN
		LDIR
		;
		; BDOS von EEPROM laden
		;
		LD	HL,EEPROMBDOS	; BDOS vom EEROM copieren
		LD	DE,BDOSBASE
		LD	BC,BDOSLEN
		LDIR
		;
		; *** ROM abschalten ***
		; Umschalten der Speicherbank von ROM -> RAM
		CALL	RAMSEL


		;Parameter setzen und Sprung zum SCCP
		;
GOCPM:		LD	A,0C3H		;JP-OPCODE
		LD	(0),A		;fuer JP BWBOOT
		LD	HL,WBOOTE	;WBOOT-Eintrittspunkt
		LD	(1),HL		;Adressfeld setzen
		;
		LD	(5),A		;fuer JP BDOS
		LD	HL,SBDOS	;SBDOS-Eintrittspunkt
		LD	(6),HL		;Adressfeld setzen
		;
		LD	BC,80H		;Standard-DMA-Adresse
		CALL	SETDMA		;setzen
		;
		LD	A,(USERLW)	;momentanes Laufwerk
		LD	C,A		;in C uebergeben
		;
		JP	SCCP		;Sprung zum SCCP






; *** CONST ***
; BIOS-Funktion (02) : CONSOLE-Status abfragen
; CONST: Status der Eingabeschnittstelle. Wurde ein Zeichen eingegeben,
; so wird im Register A der Wert OFFH bergeben, sonst 0. 
; Das Zeichen wird aber noch nicht eingelesen.
; Diese BIOS-Funktion wird vom BDOS bei jeder Zeichenausgabe
; zur Erkennung der Steuerzeichen CTRL-S und CTRL-C aufgerufen.
; Aufruf: CONST
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = 000H -> kein Zeichen
;                     Register A = 0FFH -> Zeichen vorhanden
;
CONST:
		; Laden des Connectors fuer CONIN
		LD	A,(RAM_CON_CONIN)
		LD	(RAM_AKT_CON),A
		;

		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,RE_CONST
		CALL	ITP_SEND_01
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		;
		RET



; *** CONIN ***
; BIOS-Funktion (03) : CONSOLE-Eingabe
; CONIN: A = Zeichen von der Console
; Diese Routine holt ein Zeichen von der Console (Tastatur) und
; gibt es im A-Register zurck. Falls kein Zeichen von der
; Console ansteht, mu auf ein Zeichen gewartet werden.
; Aufruf: CONIN
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = Zeichen von der Console
;    
CONIN:
		; Laden des Connectors fuer CONIN
		LD	A,(RAM_CON_CONIN)
		LD	(RAM_AKT_CON),A
		;

		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,RE_CONIN
		CALL	ITP_SEND_01
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		;
		CP	0
		JR	Z,CONIN
		;
		RET



; *** CONOUT ***
; BIOS-Funktion (04) : CONSOLE-Ausgabe
; CONOUT (CONsole OUTput) : Zeichen zur Console ausgeben, 
; Der im Register C befindliche Wert wird zur Console (Bildschirm) ausgegeben.
; Aufruf: CONOUT
; Uebergabeparameter: Register C = Zeichen im ASCII-Code
; Rueckgabeparameter: keine
;  

; Schalterverwaltung
zwei_conout		EQU	1


if	zwei_conout
  
CONOUT:

		PUSH	IX
		PUSH	IY


		; Laden des Connectors fuer CONOUT
		LD	A,(RAM_CON_CONOUT)
		LD	(RAM_AKT_CON),A
		;
		PUSH	BC		; Retten des Zeichens in C
		PUSH	BC		; Retten des Zeichens in C
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
;		LD	B,SE_LIST
		LD	B,SE_CONOUT
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;

		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		POP	BC
		;
		LD	A,(RAM_CON_CONOUT2)
		CP	0
		JR	Z,CONOUT_B
		;

		LD	(RAM_AKT_CON),A
		;
		PUSH	BC
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,SE_CONOUT
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
CONOUT_B:


		POP	IY
		POP	IX


		RET



else


CONOUT:

		PUSH	IX
		PUSH	IY

		; Laden des Connectors fuer CONOUT
		LD	A,(RAM_CON_CONOUT)
		LD	(RAM_AKT_CON),A
		;
		PUSH	BC		; Retten des Zeichens in C
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,SE_CONOUT
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;


		POP	IY
		POP	IX

		RET


endif










; *** LIST ***
; BIOS-Funktion (05) : LIST-Ausgabe
; LIST (LIST output) : Zeichen zum 'List '-Kanal (Drucker) ausgeben 
; Wie Consolenausgabe, aber zum ' List ' -Kanal.
;
; Aufruf: LIST
; Uebergabeparameter: Register C = Zeichen im ASCII-Code
; Rueckgabeparameter: keine
;   
LIST:
		; Laden des Connectors fuer LIST
		LD	A,(RAM_CON_LIST)
		LD	(RAM_AKT_CON),A
		;


		PUSH	BC		; Retten des Zeichens in C

		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,SE_LIST
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;
		RET





; *** PUNCH ***
; BIOS-Funktion (06) : PUNCH-Ausgabe
; PUNCH output : Zeichen zum ' Punch ' -Kanal ausgeben 
; Wie Consolenausgabe, aber zum ' Punch ' -Kanal
;
; Aufruf: PUNCH
; Uebergabeparameter: Register C = Zeichen im ASCII-Code
; Rueckgabeparameter: keine
;   
; *** derzeit noch nicht implementiert ***
PUNCH:
		RET





; *** READER ***
; BIOS-Funktion (07) : READER-Eingabe
; READER (READER input) : Zeichen vom ' Reader ' -Kanal holen 
; Wie Consoleneingabe , aber vom 'Reader ' -Kanal
;
; Aufruf: READER
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = Zeichen von der Console
;   
; *** derzeit noch nicht implementiert ***
READER:
		RET





; *** HOME ***
; BIOS-Funktion (08) : Spur Null einstellen
;
; Diese Funktion war bei lteren Laufwerken zur exakten
; Positionierung des Schreib/Lesekopfes gedacht.
; Da das BDOS vor jedem Diskzugriff die Spurnummer ber SETTRK
; anwhlt, ist HOHE bei neueren Laufwerken berflssig.
;
; Aufruf: HOME
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;   
HOME:
		LD	C,0
		CALL	SETTRK
		RET




; *** SELDSK ***
; BIOS-Funktion (09)   : Laufwerk auswhlen
; SELDSK (SELect DISK) : Das BIOS mu die im C-Register bergebene 
; Laufwerksnummer berprfen und, falls ein Laufwerk mit dieser Nummer 
; existiert, in HL die Adresse des zugehrigen DPH zurckgeben,
; Im CP/n ist nicht garantiert, da nach einem SELDSK-Aufruf
; auch tatschlich auf dieses Laufwerk zugegriffen wird.
; Vielmehr hat der SELDSK-Aufruf nur eine 'Anmeldefunktion',
; damit sich das BDOS auf das Laufwerk einstellen kann.
; Das BIOS mu die Laufwerksnummer aber intern speichern, da
; sich nachfolgende Diskzugriffe immer auf das zuletzt selektierte
; Laufwerk beziehen.
;
; Aufruf: SELDSK
;
; Uebergabeparameter: C   = Laufwerksnummer
;                         =  0 fr Laufwerk A:
;                           ...
;                         = 15 fr Laufwerk P:
;
;                     E,0 = Login-Bit
;                         = 0, falls das Laufwerk zum ersten Mal
;                           angewhlt wird
;                         = 1, falls das Laufwerk seit dem letzten
;                           Warmstart schonmal angewhlt wurde
;
; Rueckgabeparameter: HL -> DPH des Laufwerks
;                     HL = 0, falls das Laufwerk nicht existiert
;  
SELDSK:
		LD	HL,0		; Code bei Fehler
		LD	A,C
		CP	ANZ_LW		; Abfrage der maximalen Laufwerksnummer
		RET	NC		; RET wenn Laufwerk nicht vorhanden
		; Laufwerksnummer im erlaubten Bereich
		LD	(DISKNO),A
		; Parameterkopf-Adresse berechnen
		LD	L,A
		LD	H,0		; HL=Laufwerksnummer
		ADD	HL,HL		; *2
		ADD	HL,HL		; *4
		ADD	HL,HL		; *8
		ADD	HL,HL		; *16 (Kopf - Laenge)
		LD 	DE,DPH
		ADD	HL,DE		; HL = DPBASE (DISKNO*16)
		;
		RET





; *** SETTRK ***
; BIOS-Funktion (10) : Spurnummer auswhlen
; SETTRK (SET TRacK) : Der nchste Diskzugriff bezieht sich auf die im 
; Registerpaar BC bergebene Spur. Die so gesetzte Spurnummer, errechnet
; sich immer aus der BDOS-internen (logischen) Spurnummer plus dem OFF-Wert im DPB. 
; Wie auch beim SELDSK-Aufruf ist ein tatschlicher Diskzugriff nicht garantiert.
;
; Aufruf: SETTRK
;
; Uebergabeparameter: Register BC = Spurnummer
; Rueckgabeparameter: keine
;  
SETTRK:
		LD	(TRACK),BC
		;
		RET




; *** SETSEC ***
; BIOS-Funktion (11)  : Sektor auswhlen
; SETSEC (SET SECtor) : Logische Sektornummer setzen 
;
; Der nchste Diskzugriff bezieht sich auf den im Registerpaar
; BC bergebenen Sektor. Die so gesetzte Sektornummer ist immer
; das Ergebnis der SECTRAN-Funktion (s.u.). Auch hier ist ein
; tatschlicher Diskzugriff auf diesen Sektor nicht garantiert.
;
; Aufruf: SETSEC
;
; Uebergabeparameter: Register BC = Logische Sektornummer - Hier wird nur das niederwertige
;                                                           Byte (Reg.C) abgespeichert 
; Rueckgabeparameter: keine
;  
SETSEC:
		LD	A,C
		LD	(SECTOR),A
		;
		RET






; *** SETDMA ***
; BIOS-Funktion (12) : Datenpufferadresse setzen
;
; SETDMA (SET DMA-addresse) : Alle nachfolgenden Diskzugriffe
; mssen die DMA-Adresse als Quell- (bei Schreibzugriffen)
; bzw. Zieladresse (bei Lesezugriffen) benutzen.
; Die DMA-Adresse zeigt immer auf einen 128-Byte groen Buffer,
; weshalb Diskzugriffe immer in Recordgre erfolgen.
;
; Aufruf: SETDMA
;
; Uebergabeparameter: Register BC = DMA-Adresse
; Rueckgabeparameter: keine
;  
SETDMA:     
	LD	(DMAAD),BC
	;
	RET




; *** READ ***
; BIOS-Funktion (13) : Selektierten Sektor lesen
; READ, READ sector  : Logischen Sektor lesen
;
; Die READ-Funktion liest einen (logischen) Sektor von der Diskette 
; in den DMA-Buffer. Die Disknummer, Spurnummer und Sektornummer sind
; jeweils durch die letzten SELDSK-, SETTRKund SETSEC-Aufrufe festgelegt.
; Bei physikalischen Sektorlngen vom mehr als 128 Bytes, mu das BIOS einen 
; Sektorbuffer entsprechender Groe selbst bereitstellen und aus diesem Buffer, 
; 128 Bytes zum zuletzt definierten DMA-Buffer kopieren.
; Falls ein Lesefehler auftritt, sollte das BIOS den Diskzugriff
; ein paar Mal wiederholen und, falls der Fehler bestehen
; bleibt, den Fehlercode 1 im A-Register zurckgeben.
;
; Aufruf: READ
;
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = Fehlercode
;                                = 0, kein Fehler
;                                = 1, sonst
;  
READ:	
		; nach dem Laufwerksbuchstaben (DISKNO) wird verzweigt 
		LD	A,(DISKNO)
		CP	0
		JR	NZ,READ1
		;
		; Laufwerk A -> DISKNO=0, dann lesen von PC
		; Laden des Connectors fuer DISK
		LD	A,(RAM_CON_DISK)
		LD	(RAM_AKT_CON),A
		;
		CALL	RD_IMG_SEK
		JR	READ2
		;
READ1:
		; Laufwerk B -> DISKNO=1, dann lesen von EPROM-FLOPPY auf dem eigenen Board
		CP	1
		JR	NZ,READ3
		;
		CALL	READ_RFL
		JR	READ2
		;
READ3:
		; Laufwerk C -> DISKNO=2, dann lesen von RAMFLOPPY
		CP	2
		JR	NZ,READ2
		;
		; ist eine RAMFLOPPY angeschlossen? 
		LD	A,(RAM_CON_DISK2)
		CP	0
		;
		JR	Z,READ2
		;
		; ist eine RAMFLOPPY angeschlossen,
		; dann wird sie angesprochen
		; Laden des Connectors fuer DISK
		LD	(RAM_AKT_CON),A
		;
		CALL	RD_IMG_SEK
		;
READ2:
		XOR	A		; kein Fehler
		;
		RET




; *** WRITE ***
; BIOS-Funktion (14)  : Selektierten Sektor schreiben
; WRITE (WRITE sector): Logischen Sektor schreiben
;
; Die WRITE-Funktion schreibt einen (logischen) Sektor vom DMABuffer
; auf die Diskette. Die Disknummer, Spurnummer und Sektornummer
; sind jeweils durch die letzten SELDSK-, SETTRK- und SETSEC-Aufrufe festgelegt.
; Bei physikalischen Sektorlngen von mehr als 128 Bytes, kann das Record-Flag
; zur Realisierung eines 'Blocking'-Algorithmus verwendet werden. 
; Bei einem normalen Schreibzugriff reicht es, den logischen Sektor nur in 
; den BIOS-internen Sektorbuffer zu bernehmen.
; Dies hat den Vorteil, da nachfolgende Schreibzugriffe auf den selben
; physikalischen Sektor, keinen Diskettenzugriff verlangen.
; Erst wenn der neue logische Sektor in einem anderen physikalsichen Sektor
; liegt, mu der Sektorbuffer auf die Diskette geschrieben werden.
; Directory-Schreibzugriffe sollten immer direkt auf die
; Diskette geleitet werden.
;
; Aufruf: WRITE
;
; Uebergabeparameter: Register C = Record-Flag
;                                = 0, bei einem normalen Schreibzugriff
;                                = 1, falls der logische Sektor ein Directory-Record ist 
;                                = 2, falls der logische Sektor der erste Sektor eines neuen Blocks ist
;
; Rueckgabeparameter: Register A = Fehlercode
;                                = 0, kein Fehler
;                                = 1, sonst
;  
WRITE:		
		; nach dem Laufwerksbuchstaben (DISKNO) wird verzweigt 
		LD	A,(DISKNO)
		CP	0
		JR	NZ,WRITE1
		;
		; Laufwerk A -> DISKNO=0, dann lesen von PC
		; Laden des Connectors fuer DISK
		LD	A,(RAM_CON_DISK)
		LD	(RAM_AKT_CON),A
		;
		CALL	WR_IMG_SEK
		JR	WRITE2
		;
WRITE1:
		; Laufwerk B -> DISKNO=1, dann schreiben auf EPROM-FLOPPY auf dem eigenen Board
		CP	1
		JR	NZ,WRITE3
		;
		CALL	WRITE_RFL
		JR	WRITE2
		;
WRITE3:
		; Laufwerk C -> DISKNO=2, dann schreiben auf RAMFLOPPY
		CP	2
		JR	NZ,WRITE2
		;
		; ist eine RAMFLOPPY angeschlossen? 
		LD	A,(RAM_CON_DISK2)
		CP	0
		;
		JR	Z,WRITE2
		;
		; ist eine RAMFLOPPY angeschlossen,
		; dann wird sie angesprochen
		; Laden des Connectors fuer DISK
		LD	(RAM_AKT_CON),A
		;
		CALL	WR_IMG_SEK
		;
WRITE2:
		XOR	A		; kein Fehler
		;
		RET



; *** LISTST ***
; BIOS-Funktion (15) : LIST-Status abfragen
;
; LISTST (LIST output STatus) : Status der Druckerausgabe testen 
;
; LISTST wird vom BDOS nicht bentigt, sondern dient dem CP/M
; Hilfsprogramm 'DESPOOL1 den Status der Druckerausgabe zu
; bestimmen.
;
; Aufruf: LISTST
;
; Uebergabeparameter: keine
; Rueckgabeparameter: A = Druckerstatus
;                       = OOH, Drucker nicht bereit
;                       = FFH, Drucker frei
;  
LISTST:
		;
		LD	A,0FFH		; Drucker bereit
		;
		RET




; *** SECTRAN ***
; BIOS-Funktion (16) : Umrechnen Sektornummer
;
; SECTRAN (SECtor TRANslation) : Sektornummer aus der Sektor-Verschrnkungs-
;                                Tabelle holen 
;
; Das BDOS benutzt diese Funktion, um aus der im DPH angegebenen
; Sektor-Verschrnkungs-Tabelle die Sektornummer zu entnehmen.
; Im allgemeinen gengt es, einfach die im Registerpaar BC
; bergebene Sektornummer ins Registerpaar HL zu kopieren.
;
; Aufruf: LISTST
;
; Uebergabeparameter: Register BC = Logische Sektornummer
;                     Register DE -> Sektor-Verschrnkungs-Tabelle
;
; Rueckgabeparameter: Register HL = (Logische) Sektornummer aus der Tabelle
;  
SECTRAN:
		LD	H,B		; Laden von HL mit BC
		LD	L,C
		;
		RET




; **********************************************************





; Funktion: Anzeige der angeschlossenen Connectoren und der Geraete
;
; Aufruf: DISPLAY_CONN
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
DISPLAY_CONN:


		; Tabelle fuer Ergebnisse
		LD	HL,RAM_ITP2_IWX
		;

		; Zaehler fuer den getesteten Connector
		LD	B,5
		LD	C,'1'
		;
		
DISPLAY_CONN_A:
		LD	A,(HL)
		CP	0
		JR	Z,DISPLAY_CONN_B
		;

		; Anzeige des Connecors
		PUSH	HL
		PUSH	BC
		PUSH	AF

		LD	A,C
		LD	(CONN_NR),A

		LD	HL,ZK_CONN
		CALL	AUS_ZK

		;
		POP	AF
		;
		CP	DEVCODE_PC_CPM_EMU
		JR	NZ,DISPLAY_CONN_D
		;
		LD	HL,ZK_DEV_2
		CALL	AUS_ZK
		JR	DISPLAY_CONN_C
		;
DISPLAY_CONN_D:
		CP	DEVCODE_KEYBOARD
		JR	NZ,DISPLAY_CONN_E
		;
		LD	HL,ZK_DEV_3
		CALL	AUS_ZK
		JR	DISPLAY_CONN_C
		;
DISPLAY_CONN_E:
		CP	DEVCODE_DISPLAY
		JR	NZ,DISPLAY_CONN_F
		;
		LD	HL,ZK_DEV_4
		CALL	AUS_ZK
		JR	DISPLAY_CONN_C
		;
DISPLAY_CONN_F:
		CP	DEVCODE_RAMFLOPPY
		JR	NZ,DISPLAY_CONN_G
		;
		LD	HL,ZK_DEV_5
		CALL	AUS_ZK
		JR	DISPLAY_CONN_C
		;
DISPLAY_CONN_G:
		CP	DEVCODE_CONINOUT
		JR	NZ,DISPLAY_CONN_C
		;
		LD	HL,ZK_DEV_6
		CALL	AUS_ZK
		;

DISPLAY_CONN_C:
		POP	BC
		POP	HL

DISPLAY_CONN_B:
		INC	HL
		INC	C
		;
		DJNZ	DISPLAY_CONN_A
		;
		LD	HL,ZK_CONN_END
		CALL	AUS_ZK
		;
		RET









; Funktion: Lesen eines Sektors aus dem FLASH-ROM
;
; Aufruf: READ_RFL
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
READ_RFL:
		CALL	XLOCATE		;Berechnung der RAM-Adresse
		;
		CALL	ROMSEL
		;
		LD	DE,ROMBUFFER
		LD	BC,128		;einen Sektor lesen
		LDIR	
		;
		CALL	RAMSEL
		;
		LD	HL,ROMBUFFER
		LD	DE,(DMAAD)
		LD	BC,128		;einen Sektor schreiben
		LDIR	
		;
		RET






; Berechnen der ROM-Adresse und der Speicherbank aus TRACK und SECTOR
;
; Uebergabeparameter: keine
; Rueckgabeparameter: HL = Adresse des ROM
;
; 76543210 76543210 76543210
; --------------------------
;      111 11111100 00000000
;      876 54321098 76543210
; --------------------------
;      BBB B                 = BANK
;           AAAAAAA AAAAAAAA = Adresse (Marke2)
;            SSSSSS SSSSSSSS = S=Sector*SPT/Track (Marke1)
;      SSS SSSSSSSS SSSRRRRR = S=Sector*SPT/Track und R=Record (Marke4)
;            BBBB            = BANK (Marke3)
;
XLOCATE:	
		LD	BC,(TRACK)	; laden der Spurnummer
		LD	B,C
		LD	DE,(spt1)	; SPT1 = 64
		LD	HL,0
		;
		XOR	A
		CP	B
		JR	Z,XLOCATE2	; TRACK*SPT
		;
XLOCATE1:	ADD	HL,DE
		DJNZ	XLOCATE1
		;
XLOCATE2:	LD	A,(SECTOR)
		LD	E,A
		ADD	HL,DE		; (TRACK*SPT)+SECTOR
		;
		LD	A,H
		LD	(ROMBANK),A	; Marke3
		;
		LD	B,7
		;
XLOCATE3:	SLA	L
		RL	H
		DJNZ	XLOCATE3	; Marke4
		;
		RES	7,H		; Marke2
		;
		RET




ROMBUFFER:
		DS	128





; Funktion: Schreiben eines Sektors in den FLASH-ROM
;
; Aufruf: WRITE_RFL
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
WRITE_RFL:
		;
		XOR	A		;Fehler = 0
		RET







; Funktion: ROM (FLASH) selektieren
;
; *** ROM (FLASH) einschalten, RAM abschalten ***
; Umschalten der Speicherbank von RAM -> ROM
;
; Aufruf: ROMSEL
; nur Register A und B werden veraendert
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
ROMSEL:
		LD	A,(ROMBANK)
		;
		AND	00001111B		; nur die Bits D0..D3 sind wichtig
		LD	B,A			; Retten der Speicherbank in Reg B
		;
		LD	A,(RAM_SYSREG)
		AND	11110000B		; 0 setzen der letzten Speicherbank
		OR	B			; Uebernahme der Speicherbank in die Speicherzelle
		RES	BIT_RAMSEL,A		; aktivieren des ROM (FLASH) mit der geforderten Speicherbank
		OUT	(D_SYS_PORT),A		; Ausgabe der neuenSpeicherbank
		LD	(RAM_SYSREG),A		; Abspeichern der Speicherbank
		;
		RET





; Funktion: RAM selektieren
;
; *** RAM einschalten, ROM abschalten ***
; Umschalten der Speicherbank von ROM -> RAM
;
; Aufruf: RAMSEL
; nur Register A wird veraendert
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
RAMSEL:
		LD	A,(RAM_SYSREG)
		SET	BIT_RAMSEL,A
		OUT	(D_SYS_PORT),A
		LD	(RAM_SYSREG),A
		;
		RET






; Funktion: Hin- und Herschalten der gelben LED
;
; Aufruf: TOGGLE_LED_GE
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
TOGGLE_LED_GE:	LD	A,(RAM_SYSREG)
		OUT	(D_SYS_PORT),A
		;	
		BIT	BIT_LED_GE,A
		JR	Z,TOGGLE_LED_GE_A
		;
		RES	BIT_LED_GE,A
		;
		JR	TOGGLE_LED_GE_B
		;
TOGGLE_LED_GE_A:
		SET	BIT_LED_GE,A
		;
TOGGLE_LED_GE_B:
		LD	(RAM_SYSREG),A
		;
		RET





; Funktion: Hin- und Herschalten der roten LED
;
; Aufruf: TOGGLE_LED_RT
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
TOGGLE_LED_RT:	LD	A,(RAM_SYSREG)
		OUT	(D_SYS_PORT),A
		;	
		BIT	BIT_LED_RT,A
		JR	Z,TOGGLE_LED_RT_A
		;
		RES	BIT_LED_RT,A
		;
		JR	TOGGLE_LED_RT_B
		;
TOGGLE_LED_RT_A:
		SET	BIT_LED_RT,A
		;
TOGGLE_LED_RT_B:
		LD	(RAM_SYSREG),A
		;
		RET








; Funktion: Zeitschleife von etwa 0,1 Sekunden
;
; Aufruf: WAIT_01S
; Uebergabeparameter: Register A - 1..255 in 100 mS
; Rueckgabeparameter: keine
; 
WAIT_01S_Fak	EQU	FRQ*354/10
;
WAIT_01S:	LD	C,WAIT_01S_Fak	; 7T
		;
WAIT_01S_B:	LD	B,254		; 7T
		;
WAIT_01S_C:	DEC	B		; 4T
		JR	NZ,WAIT_01S_C	; 7T / 12T / 11T*254=2794T+12T+7T=2813T
		;
		DEC	C		; 4T
		JR	NZ,WAIT_01S_B	; 7T / 12T / 2813T+11T=2824T*141=398184T+12T+7T=398203T
		;
		DEC	A
		JR	NZ,WAIT_01S

		RET






